local AceGUI = LibStub("AceGUI-3.0")

function MorthalinRaidTools:ConstructIconToolTip(object, icons)
	if(self.ui.iconToolTip ~= nil) then
		self.ui.iconToolTip:Hide();
	end
	self.ui.iconToolTip = nil;
	if(self.ui.iconToolTip == nil) then
		local FrameBackdrop = {
			bgFile = "Interface\\DialogFrame\\UI-DialogBox-Background",
			edgeFile = "Interface\\Tooltips\\UI-Tooltip-Border",
			tile = true, tileSize = 32, edgeSize = 16,
			insets = { left = 5, right = 5, top = 5, bottom = 5 }
		}
		
		self.ui.iconToolTip = CreateFrame("Frame",nil,object);
		self.ui.iconToolTip:SetFrameStrata("TOOLTIP");
		self.ui.iconToolTip:SetWidth(71);

		self.ui.iconToolTip:EnableMouse(true);
		self.ui.iconToolTip:SetMovable(false);
		self.ui.iconToolTip:SetResizable(false);
		self.ui.iconToolTip:SetBackdrop(FrameBackdrop);
		self.ui.iconToolTip:SetBackdropColor(0, 0, 0, 1);
		self.ui.iconToolTip:SetToplevel(true);
		
	end
	self:SetIcons(icons);
	self.ui.iconToolTip:SetPoint("TOPLEFT", (self.ui.iconToolTip:GetWidth() * (-1)), 0);
end

function MorthalinRaidTools:SetIcons(icons)
	local top = 7;
	local index = 1;
	for name, data in pairs(icons) do
		for i = 1, #data do
			local iconGUI = CreateFrame("BUTTON", nil, self.ui.iconToolTip, "SecureHandlerClickTemplate");
			iconGUI:SetSize(25, 25);
			if(index % 2 == 0) then
				iconGUI:SetPoint("TOPLEFT", 39, top * (-1));
			else
				iconGUI:SetPoint("TOPLEFT", 7, top * (-1));
			end
			
			local image = iconGUI:CreateTexture(nil,"BACKGROUND",nil,-6);
			image:SetTexture(data[i].icon);
			image:SetTexCoord(0, 1, 0, 1);
			image:SetAllPoints(iconGUI);
			iconGUI:SetScript("OnEnter", function()
				GameTooltip:SetOwner(iconGUI,"ANCHOR_LEFT");
				GameTooltip:AddLine(name);
				GameTooltip:Show();
			end);
			iconGUI:SetScript("OnLeave", function() GameTooltip:Hide(); end);
			if(index % 2 == 0) then
				top = top + 32;
			end
			index = index + 1;
		end
	end
	if(index % 2 == 0) then
		top = top + 32;
	end
	if(index == 2) then
		self.ui.iconToolTip:SetWidth(39);
	end
	self.ui.iconToolTip:SetHeight(top);
	if(top == 7) then
		self.ui.iconToolTip:Hide();
	end
end