local AceGUI = LibStub("AceGUI-3.0")

local tableHeader = nil;
local mainContainer = nil;
local scrollStatistics = nil;
local sortedItemCounter = {};
local allPlayers = {};
local prevPageBtn, nextPageBtn = nil, nil;
local item1Btn, item2Btn, item3Btn, item4Btn, item5Btn, item6Btn, item7Btn, item8Btn, item9Btn = nil, nil, nil, nil, nil, nil, nil, nil, nil;
local firstIndex = 1;
local alts = {};
local sortItem = nil;
local rolls = {};

-- History toggle action
-- =========================
function MorthalinRaidTools:ToggleItemStat()
	if MorthalinRaidTools.ui.itemStatFrame:IsVisible() then
		MorthalinRaidTools.ui.itemStatFrame:Hide();
	else
		MorthalinRaidTools.ui.itemStatFrame:Show();
		MorthalinRaidTools:LoadItemsData();
		MorthalinRaidTools:UpdateItemStatView();
	end
end

local function SortItemStats(a, b)
	if(sortItem == nil) then
		return a.name < b.name;
	elseif(sortItem == -1) then
		if((rolls[a.name] == nil and 0 or rolls[a.name]) == (rolls[b.name] == nil and 0 or rolls[b.name])) then
			return a.name < b.name;
		else
			return (rolls[a.name] == nil and 0 or rolls[a.name]) > (rolls[b.name] == nil and 0 or rolls[b.name]);
		end
	else
		if(sortedItemCounter[sortItem].players == nil) then
			return a.name < b.name;
		elseif((sortedItemCounter[sortItem].players[a.name] == nil and 0 or sortedItemCounter[sortItem].players[a.name]) == (sortedItemCounter[sortItem].players[b.name] == nil and 0 or sortedItemCounter[sortItem].players[b.name])) then
			return a.name < b.name;
		else
			return (sortedItemCounter[sortItem].players[a.name] == nil and 0 or sortedItemCounter[sortItem].players[a.name]) > (sortedItemCounter[sortItem].players[b.name] == nil and 0 or sortedItemCounter[sortItem].players[b.name]);
		end
	end
end

function MorthalinRaidTools:ConstructItemStatFrame()
	self.ui.itemStatFrame = AceGUI:Create("Frame");
	self.ui.itemStatFrame:SetTitle("Items Statistics");
	self.ui.itemStatFrame:SetStatusText("");
	self.ui.itemStatFrame:SetLayout("Flow");
	self.ui.itemStatFrame:SetWidth(1050);
	self.ui.itemStatFrame:SetHeight(526);
	self.ui.itemStatFrame:EnableResize(false);
	self.ui.itemStatFrame.frame:EnableMouse(true);
	self.ui.itemStatFrame.frame:SetUserPlaced(true);
	
	local btnRollSort = AceGUI:Create("Button");
	btnRollSort:SetText("Sort by rolls");
	btnRollSort:SetCallback("OnClick", function() MorthalinRaidTools:SortItemStatByRolls(); end);
	MorthalinRaidTools.ui.itemStatFrame:AddChild(btnRollSort);
	
	-- TABLE HEADER
	tableHeader = AceGUI:Create("SimpleGroup");
	tableHeader:SetFullWidth(true);
	tableHeader:SetLayout("Flow");
	self.ui.itemStatFrame:AddChild(tableHeader);
	
	local playerBtn = AceGUI:Create("InteractiveLabel");
	playerBtn:SetWidth(150);
	playerBtn:SetText("Player");
	playerBtn.highlight:SetColorTexture(0.3, 0.3, 0.3, 0.5)
	playerBtn:SetCallback("OnClick", function() sortItem = nil; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(playerBtn);
	
	prevPageBtn = AceGUI:Create("Icon");
	prevPageBtn:SetWidth(25);
	prevPageBtn:SetHeight(20);
	prevPageBtn:SetImageSize(15,15);
	prevPageBtn.frame:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Up");
	prevPageBtn.frame:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Down");
	prevPageBtn.frame:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-PrevPage-Disabled");
	prevPageBtn.frame:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD");
	prevPageBtn:SetCallback("OnClick", function() MorthalinRaidTools:PrevPageItems(); end);
	tableHeader:AddChild(prevPageBtn);
	
	item1Btn = AceGUI:Create("Icon");
	item1Btn:SetWidth(100);
	item1Btn:SetImageSize(20,20);
	item1Btn.frame.text = item1Btn.frame:CreateFontString(nil, "ARTWORK");
	item1Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item1Btn.frame.text:SetJustifyH("CENTER");
	item1Btn.frame.text:SetJustifyV("CENTER");
	item1Btn.frame.text:SetText("Item 1");
	item1Btn.frame.text:SetAllPoints(item1Btn.frame);
	item1Btn:SetCallback("OnClick", function() sortItem = firstIndex; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item1Btn);
	
	item2Btn = AceGUI:Create("Icon");
	item2Btn:SetWidth(100);
	item2Btn:SetImageSize(20,20);
	item2Btn.frame.text = item2Btn.frame:CreateFontString(nil, "ARTWORK");
	item2Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item2Btn.frame.text:SetJustifyH("CENTER");
	item2Btn.frame.text:SetJustifyV("CENTER");
	item2Btn.frame.text:SetText("Item 2");
	item2Btn.frame.text:SetAllPoints(item2Btn.frame);
	item2Btn:SetCallback("OnClick", function() sortItem = firstIndex + 1; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item2Btn);
	
	item3Btn = AceGUI:Create("Icon");
	item3Btn:SetWidth(100);
	item3Btn:SetImageSize(20,20);
	item3Btn.frame.text = item3Btn.frame:CreateFontString(nil, "ARTWORK");
	item3Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item3Btn.frame.text:SetJustifyH("CENTER");
	item3Btn.frame.text:SetJustifyV("CENTER");
	item3Btn.frame.text:SetText("Item 3");
	item3Btn.frame.text:SetAllPoints(item3Btn.frame);
	item3Btn:SetCallback("OnClick", function() sortItem = firstIndex + 2; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item3Btn);
	
	item4Btn = AceGUI:Create("Icon");
	item4Btn:SetWidth(100);
	item4Btn:SetImageSize(20,20);
	item4Btn.frame.text = item4Btn.frame:CreateFontString(nil, "ARTWORK");
	item4Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item4Btn.frame.text:SetJustifyH("CENTER");
	item4Btn.frame.text:SetJustifyV("CENTER");
	item4Btn.frame.text:SetText("Item 4");
	item4Btn.frame.text:SetAllPoints(item4Btn.frame);
	item4Btn:SetCallback("OnClick", function() sortItem = firstIndex + 3; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item4Btn);
	
	item5Btn = AceGUI:Create("Icon");
	item5Btn:SetWidth(100);
	item5Btn:SetImageSize(20,20);
	item5Btn.frame.text = item5Btn.frame:CreateFontString(nil, "ARTWORK");
	item5Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item5Btn.frame.text:SetJustifyH("CENTER");
	item5Btn.frame.text:SetJustifyV("CENTER");
	item5Btn.frame.text:SetText("Item 5");
	item5Btn.frame.text:SetAllPoints(item5Btn.frame);
	item5Btn:SetCallback("OnClick", function() sortItem = firstIndex + 4; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item5Btn);
	
	item6Btn = AceGUI:Create("Icon");
	item6Btn:SetWidth(100);
	item6Btn:SetImageSize(20,20);
	item6Btn.frame.text = item6Btn.frame:CreateFontString(nil, "ARTWORK");
	item6Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item6Btn.frame.text:SetJustifyH("CENTER");
	item6Btn.frame.text:SetJustifyV("CENTER");
	item6Btn.frame.text:SetText("Item 6");
	item6Btn.frame.text:SetAllPoints(item6Btn.frame);
	item6Btn:SetCallback("OnClick", function() sortItem = firstIndex + 5; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item6Btn);
	
	item7Btn = AceGUI:Create("Icon");
	item7Btn:SetWidth(100);
	item7Btn:SetImageSize(20,20);
	item7Btn.frame.text = item7Btn.frame:CreateFontString(nil, "ARTWORK");
	item7Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item7Btn.frame.text:SetJustifyH("CENTER");
	item7Btn.frame.text:SetJustifyV("CENTER");
	item7Btn.frame.text:SetText("Item 7");
	item7Btn.frame.text:SetAllPoints(item7Btn.frame);
	item7Btn:SetCallback("OnClick", function() sortItem = firstIndex + 6; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item7Btn);
	
	item8Btn = AceGUI:Create("Icon");
	item8Btn:SetWidth(100);
	item8Btn:SetImageSize(20,20);
	item8Btn.frame.text = item8Btn.frame:CreateFontString(nil, "ARTWORK");
	item8Btn.frame.text:SetFont(GameFontNormal:GetFont());
	item8Btn.frame.text:SetJustifyH("CENTER");
	item8Btn.frame.text:SetJustifyV("CENTER");
	item8Btn.frame.text:SetText("Item 8");
	item8Btn.frame.text:SetAllPoints(item8Btn.frame);
	item8Btn:SetCallback("OnClick", function() sortItem = firstIndex + 7; table.sort(allPlayers, SortItemStats); MorthalinRaidTools:UpdateItemStatView(); end);
	tableHeader:AddChild(item8Btn);
	
	nextPageBtn = AceGUI:Create("Icon");
	nextPageBtn:SetWidth(25);
	nextPageBtn:SetHeight(20);
	nextPageBtn:SetImageSize(15,15);
	nextPageBtn.frame:SetNormalTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Up");
	nextPageBtn.frame:SetPushedTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Down");
	nextPageBtn.frame:SetDisabledTexture("Interface\\Buttons\\UI-SpellbookIcon-NextPage-Disabled");
	nextPageBtn.frame:SetHighlightTexture("Interface\\Buttons\\UI-Common-MouseHilight", "ADD");
	nextPageBtn:SetCallback("OnClick", function() MorthalinRaidTools:NextPageItems(); end);
	tableHeader:AddChild(nextPageBtn);
	
	--TABLE DATA PART
	mainContainer = AceGUI:Create("SimpleGroup");
	mainContainer:SetFullWidth(true);
	mainContainer:SetHeight(395);
	mainContainer:SetLayout("Fill");
	self.ui.itemStatFrame:AddChild(mainContainer);
	mainContainer:ClearAllPoints();
	mainContainer.frame:SetPoint("TOP", self.ui.itemStatFrame.frame, "BOTTOM", 0, -5);
	mainContainer.frame:SetPoint("BOTTOM", 0, 20);

	scrollStatistics = CreateFrame("ScrollFrame", nil, mainContainer.frame, "myScrollFrame");
	HybridScrollFrame_CreateButtons(scrollStatistics, "dynamicItemsListItemTemplate");
	HybridScrollFrame_SetDoNotHideScrollBar(scrollStatistics, true);
	
	scrollStatistics.update = function() 
		self:UpdateItemStatView();
	end
	
	self.ui.itemStatFrame:Hide();
end

function MorthalinRaidTools:LoadItemsData()
	alts = {};
	local allPlayersTemp = {};
	allPlayers = {};
	sortedItemCounter = {};
	
	for i=1, GetNumGuildMembers() do
		local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
		if(string.sub(officernote, 1, 4) == "Alt:") then
			if(alts[string.sub(name, 1, name:find("-") - 1)] == nil) then
				alts[string.sub(name, 1, name:find("-") - 1)] = string.sub(officernote, 5, -1);
			end
		end
	end
	
	for i = 1, #self.db.global.history do
		for j = 1, #self.db.global.history[i].members do
			local tempName = {};
			if(alts[self.db.global.history[i].members[j].name] ~= nil) then
				tempName = alts[self.db.global.history[i].members[j].name];
			else
				tempName = self.db.global.history[i].members[j].name;
			end
			
			if(allPlayersTemp[tempName] == nil) then
				local playerStatisticsTemp = 
				{
					class = {},
					color = {}
				}
				allPlayersTemp[tempName] = playerStatisticsTemp;
				if(alts[self.db.global.history[i].members[j].name] == nil) then
					allPlayersTemp[tempName].class = self.db.global.history[i].members[j].class;
					allPlayersTemp[tempName].color = self.db.global.history[i].members[j].color;
				else
					for i=1, GetNumGuildMembers() do
						local name, rank, rankIndex, level, class, zone, note, officernote, online, status = GetGuildRosterInfo(i);
						if(tempName == string.sub(name, 1, name:find("-") - 1)) then
							allPlayersTemp[tempName].class = class;
							allPlayersTemp[tempName].color = MorthalinRaidTools.classColors[class].hex;
						end
					end
				end
			end
		end
	end
	
	local function sortNames(a, b)
		return a.name < b.name;
	end
	
	for name, data in pairs(allPlayersTemp) do
		table.insert(allPlayers, {name = name, class = data.class, color = data.color});
	end
	table.sort(allPlayers, sortNames);
	
	
	
	for name, data in pairs(MorthalinRaidTools.db.global.itemCounter) do
		table.insert(sortedItemCounter, {name = name, icon = data.icon, players = {}});
		for player, count in pairs(data.players) do
			sortedItemCounter[#sortedItemCounter].players[player] = count;
		end
		for player, count in pairs(sortedItemCounter[#sortedItemCounter].players) do
			if(alts[player] ~= nil) then
				if(sortedItemCounter[#sortedItemCounter].players[alts[player]] == nil) then
					sortedItemCounter[#sortedItemCounter].players[alts[player]] = 0;
				end
				sortedItemCounter[#sortedItemCounter].players[alts[player]] = sortedItemCounter[#sortedItemCounter].players[alts[player]] + sortedItemCounter[#sortedItemCounter].players[player];
				sortedItemCounter[#sortedItemCounter].players[player] = nil;
			end
		end
	end
	table.sort(sortedItemCounter, sortNames);
	
	MorthalinRaidTools:ShowItemColumns();
end

function MorthalinRaidTools:UpdateItemStatView()
	local buttons = HybridScrollFrame_GetButtons(scrollStatistics);
	local offset = HybridScrollFrame_GetOffset(scrollStatistics);
	for buttonIndex = 1, #buttons do
		local button = buttons[buttonIndex];
		local itemIndex = buttonIndex + offset;
		
		if (itemIndex <= #allPlayers) then
			button:SetID(itemIndex);
			button.Player:SetText("|cff" .. (type(allPlayers[itemIndex].color) == "string" and allPlayers[itemIndex].color or "ff0000") .. allPlayers[itemIndex].name .. (sortItem == -1 and ((rolls[allPlayers[itemIndex].name] == nil and "" or "|r (" .. tostring(rolls[allPlayers[itemIndex].name]) .. ")")) or ""));
			button:SetScript('OnEnter', function() self:ShowAlts(button, allPlayers[itemIndex].name, alts) end);
			button:SetScript('OnLeave', function() self:HideTooltip() end);
			if(sortedItemCounter[firstIndex] ~= nil) then
				button.Text1:SetText(sortedItemCounter[firstIndex].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex].players[allPlayers[itemIndex].name]));
			else
				button.Text1:SetText("");
			end
			if(sortedItemCounter[firstIndex + 1] ~= nil) then
				button.Text2:SetText(sortedItemCounter[firstIndex + 1].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 1].players[allPlayers[itemIndex].name]));
			else
				button.Text2:SetText("");
			end
			if(sortedItemCounter[firstIndex + 2] ~= nil) then
				button.Text3:SetText(sortedItemCounter[firstIndex + 2].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 2].players[allPlayers[itemIndex].name]));
			else
				button.Text3:SetText("");
			end
			if(sortedItemCounter[firstIndex + 3] ~= nil) then
				button.Text4:SetText(sortedItemCounter[firstIndex + 3].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 3].players[allPlayers[itemIndex].name]));
			else
				button.Text4:SetText("");
			end
			if(sortedItemCounter[firstIndex + 4] ~= nil) then
				button.Text5:SetText(sortedItemCounter[firstIndex + 4].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 4].players[allPlayers[itemIndex].name]));
			else
				button.Text5:SetText("");
			end
			if(sortedItemCounter[firstIndex + 5] ~= nil) then
				button.Text6:SetText(sortedItemCounter[firstIndex + 5].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 5].players[allPlayers[itemIndex].name]));
			else
				button.Text6:SetText("");
			end
			if(sortedItemCounter[firstIndex + 6] ~= nil) then
				button.Text7:SetText(sortedItemCounter[firstIndex + 6].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 6].players[allPlayers[itemIndex].name]));
			else
				button.Text7:SetText("");
			end
			if(sortedItemCounter[firstIndex + 7] ~= nil) then
				button.Text8:SetText(sortedItemCounter[firstIndex + 7].players[allPlayers[itemIndex].name] == nil and "0" or tostring(sortedItemCounter[firstIndex + 7].players[allPlayers[itemIndex].name]));
			else
				button.Text8:SetText("");
			end
			button.LeftSpace:SetText("");
			button.rightSpace:SetText("");
			button:Show();
		else
			button:Hide();
		end
	end

	local buttonHeight = scrollStatistics.buttonHeight;
	local totalHeight = #allPlayers * buttonHeight;
	local shownHeight = #buttons * buttonHeight;

	HybridScrollFrame_Update(scrollStatistics, totalHeight, shownHeight);
end

function MorthalinRaidTools:ShowItemColumns()
	if(sortedItemCounter[firstIndex] ~= nil) then
		item1Btn.frame:Show();
		if(sortedItemCounter[firstIndex].icon ~= nil) then
			item1Btn.image:SetTexture(sortedItemCounter[firstIndex].icon);
			item1Btn.frame.text:SetText("");
		else
			item1Btn.image:SetTexture(nil);
			item1Btn.frame.text:SetText(sortedItemCounter[firstIndex].name);
		end
		item1Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item1Btn.frame, sortedItemCounter[firstIndex].name) end);
		item1Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item1Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 1] ~= nil) then
		item2Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 1].icon ~= nil) then
			item2Btn.image:SetTexture(sortedItemCounter[firstIndex + 1].icon);
			item2Btn.frame.text:SetText("");
		else
			item2Btn.image:SetTexture(nil);
			item2Btn.frame.text:SetText(sortedItemCounter[firstIndex + 1].name);
		end
		item2Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item2Btn.frame, sortedItemCounter[firstIndex + 1].name) end);
		item2Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item2Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 2] ~= nil) then
		item3Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 2].icon ~= nil) then
			item3Btn.image:SetTexture(sortedItemCounter[firstIndex + 2].icon);
			item3Btn.frame.text:SetText("");
		else
			item3Btn.image:SetTexture(nil);
			item3Btn.frame.text:SetText(sortedItemCounter[firstIndex + 2].name);
		end
		item3Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item3Btn.frame, sortedItemCounter[firstIndex + 2].name) end);
		item3Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item3Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 3] ~= nil) then
		item4Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 3].icon ~= nil) then
			item4Btn.image:SetTexture(sortedItemCounter[firstIndex + 3].icon);
			item4Btn.frame.text:SetText("");
		else
			item4Btn.image:SetTexture(nil);
			item4Btn.frame.text:SetText(sortedItemCounter[firstIndex + 3].name);
		end
		item4Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item4Btn.frame, sortedItemCounter[firstIndex + 3].name) end);
		item4Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item4Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 4] ~= nil) then
		item5Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 4].icon ~= nil) then
			item5Btn.image:SetTexture(sortedItemCounter[firstIndex + 4].icon);
			item5Btn.frame.text:SetText("");
		else
			item5Btn.image:SetTexture(nil);
			item5Btn.frame.text:SetText(sortedItemCounter[firstIndex + 4].name);
		end
		item5Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item5Btn.frame, sortedItemCounter[firstIndex + 4].name) end);
		item5Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item5Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 5] ~= nil) then
		item6Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 5].icon ~= nil) then
			item6Btn.image:SetTexture(sortedItemCounter[firstIndex + 5].icon);
			item6Btn.frame.text:SetText("");
		else
			item6Btn.image:SetTexture(nil);
			item6Btn.frame.text:SetText(sortedItemCounter[firstIndex + 5].name);
		end
		item6Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item6Btn.frame, sortedItemCounter[firstIndex + 5].name) end);
		item6Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item6Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 6] ~= nil) then
		item7Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 6].icon ~= nil) then
			item7Btn.image:SetTexture(sortedItemCounter[firstIndex + 6].icon);
			item7Btn.frame.text:SetText("");
		else
			item7Btn.image:SetTexture(nil);
			item7Btn.frame.text:SetText(sortedItemCounter[firstIndex + 6].name);
		end
		item7Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item7Btn.frame, sortedItemCounter[firstIndex + 6].name) end);
		item7Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item7Btn.frame:Hide();
	end
	if(sortedItemCounter[firstIndex + 7] ~= nil) then
		item8Btn.frame:Show();
		if(sortedItemCounter[firstIndex + 7].icon ~= nil) then
			item8Btn.image:SetTexture(sortedItemCounter[firstIndex + 7].icon);
			item8Btn.frame.text:SetText("");
		else
			item8Btn.image:SetTexture(nil);
			item8Btn.frame.text:SetText(sortedItemCounter[firstIndex + 7].name);
		end
		item8Btn:SetCallback('OnEnter', function() self:ShowToolTipOneRow(item8Btn.frame, sortedItemCounter[firstIndex + 7].name) end);
		item8Btn:SetCallback('OnLeave', function() self:HideTooltip(); end);
	else
		item8Btn.frame:Hide();
	end
	
	if(firstIndex == 1) then
		prevPageBtn:SetDisabled(true);
	else
		prevPageBtn:SetDisabled(false);
	end
	
	if(firstIndex + 8 > #sortedItemCounter) then
		nextPageBtn:SetDisabled(true);
	else
		nextPageBtn:SetDisabled(false);
	end
end

function MorthalinRaidTools:PrevPageItems()
	if(firstIndex - 8 < 1) then
		firstIndex = 1;
	else
		firstIndex = firstIndex - 8;
	end
	MorthalinRaidTools:ShowItemColumns();
	MorthalinRaidTools:UpdateItemStatView();
end

function MorthalinRaidTools:NextPageItems()
	firstIndex = firstIndex + 8;
	MorthalinRaidTools:ShowItemColumns();
	MorthalinRaidTools:UpdateItemStatView();
end

function MorthalinRaidTools:ShowToolTipOneRow(obj, text)
	GameTooltip:SetOwner(obj,"ANCHOR_LEFT");
	GameTooltip:AddLine(text);
	GameTooltip:Show();
end

function MorthalinRaidTools:SortItemStatByRolls()
	rolls = {};
	for name, roll in pairs(MorthalinRaidTools.db.global.itemRollsCounter) do
		if(alts[name] ~= nil) then
			rolls[alts[name]] = roll;
		else
			rolls[name] = roll;
		end
	end
	sortItem = -1;
	table.sort(allPlayers, SortItemStats);
	MorthalinRaidTools:UpdateItemStatView();
end
